// variáveis para controlar o botão
int duration = 5000;
int debounce_delay = 800;
int pedido_peao = 0;
int pedido_estado = 0;

// portas de ligação ao arduino
const byte NOTE_A6 = 1760;
const byte PEAO_GREEN = 2;
const byte PEAO_RED = 3;
const byte BUTTON = 5;
const byte BELL = 6;
const byte CAR_GREEN = 8;
const byte CAR_YELLOW = 9;
const byte CAR_RED = 10;

// configuração
void setup(){
  // semaforo peoes
  pinMode(PEAO_GREEN, OUTPUT);
  digitalWrite(PEAO_GREEN, LOW);
  pinMode(PEAO_RED, OUTPUT);
  digitalWrite(PEAO_RED, HIGH);
  
  // semaforo transito
  pinMode(CAR_GREEN, OUTPUT);
  digitalWrite(CAR_GREEN, HIGH);
  pinMode(CAR_YELLOW, OUTPUT);
  digitalWrite(CAR_YELLOW, LOW);
  pinMode(CAR_RED, OUTPUT);
  digitalWrite(CAR_RED, LOW);
  
  // botao peoes
  pinMode(BUTTON, INPUT);
}

// programa
void loop(){
  // detetar botao pressionado, com proteção debounce
  // http://arduino.cc/it/Tutorial/Debounce
  int ms = millis();
  byte pedido = digitalRead(BUTTON);
  
  if( pedido == 1 && (ms - debounce_delay) > pedido_peao ){
   pararCarros();
   peoes();
   arrancarCarros();
   pedido_estado = 1;
   
  } else if( pedido != pedido_estado ){
    pedido_peao = ms;
  }
  
  pedido_estado = pedido;
}

// função para ativar o sinal vermelho para carros, de forma sequencial
// (amarelo, vermelho)
void pararCarros(){
  delay(1000);
  digitalWrite(CAR_GREEN, LOW); 
  digitalWrite(CAR_YELLOW, HIGH);
  
  delay(1000);
  digitalWrite(CAR_YELLOW, LOW);
  digitalWrite(CAR_RED, HIGH);
  
  delay(1500);
}

// função para dar luz verde aos carros
void arrancarCarros(){
  digitalWrite(CAR_RED, LOW); 
  digitalWrite(CAR_YELLOW, LOW);
  digitalWrite(CAR_GREEN, HIGH);
}

// função que ativa sinal verde para peões, espera,
// emite sinal sonoro (se for colocado umm buzzer) e
// ativa o sinal vermelho de novo
void peoes(){
  digitalWrite(PEAO_RED, LOW);
  digitalWrite(PEAO_GREEN, HIGH);
  
  delay(5000);
  piscaLuz(PEAO_GREEN, 5, 400);
  digitalWrite(PEAO_GREEN, LOW);
  digitalWrite(PEAO_RED, HIGH);
  delay(2000);
}

// faz piscar uma determinada luz, um certo número de veze
void piscaLuz(byte luz, byte vezes, int tempo){
  for(byte i = 0; i < vezes; i++ ){
    digitalWrite(luz, LOW);
    tone(BELL, NOTE_A6, 1000/2);
    delay(tempo);
    digitalWrite(luz, HIGH);
    delay(tempo);
    noTone(BELL);
  }
}
